Index: /LMDZ5/branches/testing/libf/phylmd/physiq.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/physiq.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/physiq.F90	(revision 2408)
@@ -3629,8 +3784,8 @@
   IF (ip_ebil_phy.ge.2) THEN 
      ztit='after rad'
-     CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime &
+     CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,2,dtime &
           , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
           , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
-     call diagphy(airephy,ztit,ip_ebil_phy &
+     call diagphy(cell_area,ztit,ip_ebil_phy &
           , topsw, toplw, solsw, sollw, zero_v &
           , zero_v, zero_v, zero_v, ztsol &
@@ -3705,8 +3860,8 @@
   !
   if (mydebug) then
-     call writefield_phy('u_seri',u_seri,llm)
-     call writefield_phy('v_seri',v_seri,llm)
-     call writefield_phy('t_seri',t_seri,llm)
-     call writefield_phy('q_seri',q_seri,llm)
+     call writefield_phy('u_seri',u_seri,nbp_lev)
+     call writefield_phy('v_seri',v_seri,nbp_lev)
+     call writefield_phy('t_seri',t_seri,nbp_lev)
+     call writefield_phy('q_seri',q_seri,nbp_lev)
   endif
 
@@ -3742,23 +3897,48 @@
              d_t_lif, d_u_lif, d_v_lif)
      ENDIF
-     !   
-     !-----------------------------------------------------------------------------------------
+
      ! ajout des tendances de la portance de l'orographie
-     CALL add_phys_tend(d_u_lif,d_v_lif,d_t_lif,dq0,dql0,dqi0,paprs,'lif',abortphy)
-     !-----------------------------------------------------------------------------------------
-     !
+     CALL add_phys_tend(d_u_lif, d_v_lif, d_t_lif, dq0, dql0, dqi0, paprs, &
+          'lif', abortphy)
   ENDIF ! fin de test sur ok_orolf
-  !  HINES GWD PARAMETRIZATION
 
   IF (ok_hines) then
-
-     CALL hines_gwd(klon,klev,dtime,paprs,pplay, &
-          rlat,t_seri,u_seri,v_seri, &
-          zustrhi,zvstrhi, &
-          d_t_hin, d_u_hin, d_v_hin)
-     !
-     !  ajout des tendances
-     CALL add_phys_tend(d_u_hin,d_v_hin,d_t_hin,dq0,dql0,dqi0,paprs,'hin',abortphy)
-
+     !  HINES GWD PARAMETRIZATION
+     east_gwstress=0.
+     west_gwstress=0.
+     du_gwd_hines=0.
+     dv_gwd_hines=0.
+     CALL hines_gwd(klon, klev, dtime, paprs, pplay, rlat, t_seri, u_seri, &
+          v_seri, zustr_gwd_hines, zvstr_gwd_hines, d_t_hin, du_gwd_hines, &
+          dv_gwd_hines)
+     zustr_gwd_hines=0.
+     zvstr_gwd_hines=0.
+     DO k = 1, klev
+        zustr_gwd_hines(:)=zustr_gwd_hines(:)+ du_gwd_hines(:, k)/dtime &
+             * (paprs(:, k)-paprs(:, k+1))/rg
+        zvstr_gwd_hines(:)=zvstr_gwd_hines(:)+ dv_gwd_hines(:, k)/dtime &
+             * (paprs(:, k)-paprs(:, k+1))/rg
+     ENDDO
+
+     d_t_hin(:, :)=0.
+     CALL add_phys_tend(du_gwd_hines, dv_gwd_hines, d_t_hin, dq0, dql0, dqi0, &
+          paprs, 'hin', abortphy)
+  ENDIF
+
+  IF (.not. ok_hines .and. ok_gwd_rando) then
+     CALL acama_GWD_rando(DTIME, pplay, rlat, t_seri, u_seri, v_seri, rot, &
+          zustr_gwd_front, zvstr_gwd_front, du_gwd_front, dv_gwd_front, &
+          east_gwstress, west_gwstress)
+     zustr_gwd_front=0.
+     zvstr_gwd_front=0.
+     DO k = 1, klev
+        zustr_gwd_front(:)=zustr_gwd_front(:)+ du_gwd_front(:, k)/dtime &
+             * (paprs(:, k)-paprs(:, k+1))/rg
+        zvstr_gwd_front(:)=zvstr_gwd_front(:)+ dv_gwd_front(:, k)/dtime &
+             * (paprs(:, k)-paprs(:, k+1))/rg
+     ENDDO
+
+     CALL add_phys_tend(du_gwd_front, dv_gwd_front, dt0, dq0, dql0, dqi0, &
+          paprs, 'front_gwd_rando', abortphy)
   ENDIF
 
@@ -3766,7 +3946,15 @@
      call FLOTT_GWD_rando(DTIME, pplay, t_seri, u_seri, v_seri, &
           rain_fall + snow_fall, zustr_gwd_rando, zvstr_gwd_rando, &
-          du_gwd_rando, dv_gwd_rando)
-     CALL add_phys_tend(du_gwd_rando, dv_gwd_rando, dt0, dq0, dql0,dqi0,paprs, &
-          'flott_gwd_rando',abortphy)
+          du_gwd_rando, dv_gwd_rando, east_gwstress, west_gwstress)
+     CALL add_phys_tend(du_gwd_rando, dv_gwd_rando, dt0, dq0, dql0, dqi0, &
+          paprs, 'flott_gwd_rando', abortphy)
+     zustr_gwd_rando=0.
+     zvstr_gwd_rando=0.
+     DO k = 1, klev
+        zustr_gwd_rando(:)=zustr_gwd_rando(:)+ du_gwd_rando(:, k)/dtime &
+             * (paprs(:, k)-paprs(:, k+1))/rg
+        zvstr_gwd_rando(:)=zvstr_gwd_rando(:)+ dv_gwd_rando(:, k)/dtime &
+             * (paprs(:, k)-paprs(:, k+1))/rg
+     ENDDO
   end if
 
@@ -3774,8 +3962,8 @@
 
   if (mydebug) then
-     call writefield_phy('u_seri',u_seri,llm)
-     call writefield_phy('v_seri',v_seri,llm)
-     call writefield_phy('t_seri',t_seri,llm)
-     call writefield_phy('q_seri',q_seri,llm)
+     call writefield_phy('u_seri',u_seri,nbp_lev)
+     call writefield_phy('v_seri',v_seri,nbp_lev)
+     call writefield_phy('t_seri',t_seri,nbp_lev)
+     call writefield_phy('q_seri',q_seri,nbp_lev)
   endif
 
@@ -3808,8 +3996,8 @@
   IF (ip_ebil_phy.ge.2) THEN 
      ztit='after orography'
-     CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime &
+     CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,2,dtime &
           , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
           , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
-     call diagphy(airephy,ztit,ip_ebil_phy &
+     call diagphy(cell_area,ztit,ip_ebil_phy &
           , zero_v, zero_v, zero_v, zero_v, zero_v &
           , zero_v, zero_v, zero_v, ztsol &
@@ -3822,5 +4010,6 @@
      CALL METHOX(1,klon,klon,klev,q_seri,d_q_ch4,pplay)
   ! ajout de la tendance d'humidite due au methane
-     CALL add_phys_tend(du0,dv0,dt0,d_q_ch4*dtime,dql0,'q_ch4',abortphy)
+     CALL add_phys_tend(du0, dv0, dt0, d_q_ch4*dtime, dql0, dqi0, paprs, &
+          'q_ch4', abortphy)
   END IF
   !
@@ -3915,5 +4104,5 @@
           cdragh,coefh(1:klon,1:klev,is_ave),u1,v1,ftsol,pctsrf, &
           frac_impa, frac_nucl, &
-          pphis,airephy,dtime,itap, &
+          pphis,cell_area,dtime,itap, &
           qx(:,:,ivap),da,phi,mp,upwd,dnwd)
 
@@ -3946,5 +4135,5 @@
 
   d_t_ec(:,:)=0.
-  forall (k=1: llm) exner(:, k) = (pplay(:, k)/paprs(:,1))**RKAPPA
+  forall (k=1: nbp_lev) exner(:, k) = (pplay(:, k)/paprs(:,1))**RKAPPA
   CALL ener_conserv(klon,klev,pdtphys,u,v,t,qx(:,:,ivap), &
        u_seri,v_seri,t_seri,q_seri,pbl_tke(:,:,is_ave)-tke0(:,:), &
@@ -3955,5 +4144,5 @@
   IF (ip_ebil_phy.ge.1) THEN 
      ztit='after physic'
-     CALL diagetpq(airephy,ztit,ip_ebil_phy,1,1,dtime &
+     CALL diagetpq(cell_area,ztit,ip_ebil_phy,1,1,dtime &
           , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
           , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
@@ -3963,5 +4152,5 @@
      !     Donc la somme de ces 2 variations devrait etre nulle.
 
-     call diagphy(airephy,ztit,ip_ebil_phy &
+     call diagphy(cell_area,ztit,ip_ebil_phy &
           , topsw, toplw, solsw, sollw, sens &
           , evap, rain_fall, snow_fall, ztsol &
@@ -3998,6 +4187,6 @@
   include "calcul_STDlev.h"
   !
-  ! slp sea level pressure
-  slp(:) = paprs(:,1)*exp(pphis(:)/(RD*t_seri(:,1)))
+  ! slp sea level pressure derived from Arpege-IFS : CALL ctstar + CALL pppmer
+  CALL diag_slp(klon,t_seri,paprs,pplay,pphis,ptstar,pt0,slp)
   !
   !cc prw = eau precipitable
@@ -4023,5 +4212,5 @@
           paprs, &
           q_seri, &
-          airephy, &
+          cell_area, &
           pphi, &
           pphis, &
@@ -4042,8 +4231,8 @@
   !
   if (mydebug) then
-     call writefield_phy('u_seri',u_seri,llm)
-     call writefield_phy('v_seri',v_seri,llm)
-     call writefield_phy('t_seri',t_seri,llm)
-     call writefield_phy('q_seri',q_seri,llm)
+     call writefield_phy('u_seri',u_seri,nbp_lev)
+     call writefield_phy('v_seri',v_seri,nbp_lev)
+     call writefield_phy('t_seri',t_seri,nbp_lev)
+     call writefield_phy('q_seri',q_seri,nbp_lev)
   endif
 
@@ -4133,9 +4322,16 @@
      enddo
 
-     write(lunout,*) 'd_t_oli,d_t_vdf,d_t_oro,d_t_lif,d_t_ec'
+!jyg<     (En attendant de statuer sur le sort de d_t_oli)
+!jyg!     write(lunout,*) 'd_t_oli,d_t_vdf,d_t_oro,d_t_lif,d_t_ec'
+!jyg!     do k=1,klev
+!jyg!        write(lunout,*) d_t_oli(igout,k),d_t_vdf(igout,k), &
+!jyg!             d_t_oro(igout,k),d_t_lif(igout,k),d_t_ec(igout,k)
+!jyg!     enddo
+     write(lunout,*) 'd_t_vdf,d_t_oro,d_t_lif,d_t_ec'
      do k=1,klev
-        write(lunout,*) d_t_oli(igout,k),d_t_vdf(igout,k), &
+        write(lunout,*) d_t_vdf(igout,k), &
              d_t_oro(igout,k),d_t_lif(igout,k),d_t_ec(igout,k)
      enddo
+!>jyg
 
      write(lunout,*) 'd_ps ',d_ps(igout)
@@ -4238,5 +4434,5 @@
     IF (abortphy==1) THEN
        abort_message ='Plantage hgardfou'
-       CALL abort_gcm (modname,abort_message,1)
+       CALL abort_physic (modname,abort_message,1)
     ENDIF
 
@@ -4248,57 +4444,4 @@
   !====================================================================
   !
-
-  !        -----------------------------------------------------------------
-  !        WSTATS: Saving statistics
-  !        -----------------------------------------------------------------
-  !        ("stats" stores and accumulates 8 key variables in file "stats.nc"
-  !        which can later be used to make the statistic files of the run:
-  !        "stats")          only possible in 3D runs !
-
-
-  IF (callstats) THEN
-
-     call wstats(klon,o_psol%name,"Surface pressure","Pa" &
-          ,2,paprs(:,1))
-     call wstats(klon,o_tsol%name,"Surface temperature","K", &
-          2,zxtsol)
-     zx_tmp_fi2d(:) = rain_fall(:) + snow_fall(:)
-     call wstats(klon,o_precip%name,"Precip Totale liq+sol", &
-          "kg/(s*m2)",2,zx_tmp_fi2d)
-     zx_tmp_fi2d(:) = rain_lsc(:) + snow_lsc(:)
-     call wstats(klon,o_plul%name,"Large-scale Precip", &
-          "kg/(s*m2)",2,zx_tmp_fi2d)
-     zx_tmp_fi2d(:) = rain_con(:) + snow_con(:)
-     call wstats(klon,o_pluc%name,"Convective Precip", &
-          "kg/(s*m2)",2,zx_tmp_fi2d)
-     call wstats(klon,o_sols%name,"Solar rad. at surf.", &
-          "W/m2",2,solsw)
-     call wstats(klon,o_soll%name,"IR rad. at surf.", &
-          "W/m2",2,sollw)
-     zx_tmp_fi2d(:) = topsw(:)-toplw(:)
-     call wstats(klon,o_nettop%name,"Net dn radiatif flux at TOA", &
-          "W/m2",2,zx_tmp_fi2d)
-
-
-
-     call wstats(klon,o_temp%name,"Air temperature","K", &
-          3,t_seri)
-     call wstats(klon,o_vitu%name,"Zonal wind","m.s-1", &
-          3,u_seri)
-     call wstats(klon,o_vitv%name,"Meridional wind", &
-          "m.s-1",3,v_seri)
-     call wstats(klon,o_vitw%name,"Vertical wind", &
-          "m.s-1",3,omega)
-     call wstats(klon,o_ovap%name,"Specific humidity", "kg/kg", &
-          3,q_seri)
-
-
-
-     IF(lafin) THEN
-        write (*,*) "Writing stats..."
-        call mkstats(ierr)
-     ENDIF
-
-  ENDIF !if callstats
 
   IF (lafin) THEN
Index: /LMDZ5/branches/testing/libf/phylmd/phystokenc_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phystokenc_mod.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phylmd/phystokenc_mod.F90	(revision 2408)
@@ -0,0 +1,387 @@
+!
+! $Id$
+!
+MODULE phystokenc_mod
+
+  IMPLICIT NONE
+
+  LOGICAL,SAVE :: offline
+!$OMP THREADPRIVATE(offline)
+  INTEGER,SAVE :: istphy
+!$OMP THREADPRIVATE(istphy)
+
+
+CONTAINS
+
+  SUBROUTINE init_phystokenc(offline_dyn,istphy_dyn)
+    IMPLICIT NONE
+    LOGICAL,INTENT(IN) :: offline_dyn
+    INTEGER,INTENT(IN) :: istphy_dyn
+
+    offline=offline_dyn
+    istphy=istphy_dyn
+
+  END SUBROUTINE init_phystokenc
+
+SUBROUTINE phystokenc (nlon,nlev,pdtphys,rlon,rlat, &
+     pt,pmfu, pmfd, pen_u, pde_u, pen_d, pde_d, &
+     pfm_therm,pentr_therm, &
+     cdragh, pcoefh,yu1,yv1,ftsol,pctsrf, &
+     frac_impa,frac_nucl, &
+     pphis,paire,dtime,itap, &
+     psh, pda, pphi, pmp, pupwd, pdnwd)
+  
+  USE ioipsl
+  USE dimphy
+  USE infotrac_phy, ONLY : nqtot
+  USE iophy
+  USE indice_sol_mod
+  USE print_control_mod, ONLY: lunout
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
+  
+  IMPLICIT NONE
+  
+!======================================================================
+! Auteur(s) FH
+! Objet: Ecriture des variables pour transport offline
+!
+!======================================================================
+
+! Arguments:
+!
+  REAL,DIMENSION(klon,klev), INTENT(IN)     :: psh   ! humidite specifique
+  REAL,DIMENSION(klon,klev), INTENT(IN)     :: pda
+  REAL,DIMENSION(klon,klev,klev), INTENT(IN):: pphi
+  REAL,DIMENSION(klon,klev), INTENT(IN)     :: pmp
+  REAL,DIMENSION(klon,klev), INTENT(IN)     :: pupwd ! saturated updraft mass flux
+  REAL,DIMENSION(klon,klev), INTENT(IN)     :: pdnwd ! saturated downdraft mass flux
+
+!   EN ENTREE:
+!   ==========
+!
+!   divers:
+!   -------
+!
+  INTEGER nlon ! nombre de points horizontaux
+  INTEGER nlev ! nombre de couches verticales
+  REAL pdtphys ! pas d'integration pour la physique (seconde)
+  INTEGER itap
+  INTEGER, SAVE :: physid
+!$OMP THREADPRIVATE(physid)
+
+!   convection:
+!   -----------
+!
+  REAL pmfu(klon,klev)  ! flux de masse dans le panache montant
+  REAL pmfd(klon,klev)  ! flux de masse dans le panache descendant
+  REAL pen_u(klon,klev) ! flux entraine dans le panache montant
+  REAL pde_u(klon,klev) ! flux detraine dans le panache montant
+  REAL pen_d(klon,klev) ! flux entraine dans le panache descendant
+  REAL pde_d(klon,klev) ! flux detraine dans le panache descendant
+  REAL pt(klon,klev)
+  REAL,ALLOCATABLE,SAVE :: t(:,:)
+!$OMP THREADPRIVATE(t)
+!
+  REAL rlon(klon), rlat(klon), dtime
+  REAL zx_tmp_3d(nbp_lon,nbp_lat,klev),zx_tmp_2d(nbp_lon,nbp_lat)
+
+!   Couche limite:
+!   --------------
+!
+  REAL cdragh(klon)          ! cdrag
+  REAL pcoefh(klon,klev)     ! coeff melange CL
+  REAL pcoefh_buf(klon,klev) ! coeff melange CL + cdrag
+  REAL yv1(klon)
+  REAL yu1(klon),pphis(klon),paire(klon)
+
+!   Les Thermiques : (Abderr 25 11 02)
+!   ---------------
+  REAL, INTENT(IN) ::  pfm_therm(klon,klev+1)
+  REAL pentr_therm(klon,klev)
+  
+  REAL,ALLOCATABLE,SAVE :: entr_therm(:,:)
+  REAL,ALLOCATABLE,SAVE :: fm_therm(:,:)
+!$OMP THREADPRIVATE(entr_therm)
+!$OMP THREADPRIVATE(fm_therm)
+!
+!   Lessivage:
+!   ----------
+!
+  REAL frac_impa(klon,klev)
+  REAL frac_nucl(klon,klev)
+!
+! Arguments necessaires pour les sources et puits de traceur
+!
+  REAL ftsol(klon,nbsrf)  ! Temperature du sol (surf)(Kelvin)
+  REAL pctsrf(klon,nbsrf) ! Pourcentage de sol f(nature du sol)
+!======================================================================
+!
+  INTEGER i, k, kk
+  REAL,ALLOCATABLE,SAVE :: mfu(:,:)  ! flux de masse dans le panache montant
+  REAL,ALLOCATABLE,SAVE :: mfd(:,:)  ! flux de masse dans le panache descendant
+  REAL,ALLOCATABLE,SAVE :: en_u(:,:) ! flux entraine dans le panache montant
+  REAL,ALLOCATABLE,SAVE :: de_u(:,:) ! flux detraine dans le panache montant
+  REAL,ALLOCATABLE,SAVE :: en_d(:,:) ! flux entraine dans le panache descendant
+  REAL,ALLOCATABLE,SAVE :: de_d(:,:) ! flux detraine dans le panache descendant
+  REAL,ALLOCATABLE,SAVE :: coefh(:,:) ! flux detraine dans le panache descendant
+  
+  REAL,ALLOCATABLE,SAVE :: pyu1(:)
+  REAL,ALLOCATABLE,SAVE :: pyv1(:)
+  REAL,ALLOCATABLE,SAVE :: pftsol(:,:)
+  REAL,ALLOCATABLE,SAVE :: ppsrf(:,:)
+!$OMP THREADPRIVATE(mfu,mfd,en_u,de_u,en_d,de_d,coefh)
+!$OMP THREADPRIVATE(pyu1,pyv1,pftsol,ppsrf)
+
+
+  REAL,DIMENSION(:,:), ALLOCATABLE,SAVE     :: sh  
+  REAL,DIMENSION(:,:), ALLOCATABLE,SAVE     :: da
+  REAL,DIMENSION(:,:,:), ALLOCATABLE,SAVE   :: phi
+  REAL,DIMENSION(:,:), ALLOCATABLE,SAVE     :: mp
+  REAL,DIMENSION(:,:), ALLOCATABLE,SAVE     :: upwd
+  REAL,DIMENSION(:,:), ALLOCATABLE,SAVE     :: dnwd
+  
+  REAL, SAVE :: dtcum
+  INTEGER, SAVE:: iadvtr=0
+!$OMP THREADPRIVATE(dtcum,iadvtr)
+  REAL zmin,zmax
+  LOGICAL ok_sync
+  CHARACTER(len=12) :: nvar
+  logical, parameter :: lstokenc=.FALSE.
+!
+!======================================================================
+
+  iadvtr=iadvtr+1
+
+! Dans le meme vecteur on recombine le drag et les coeff d'echange
+  pcoefh_buf(:,1)      = cdragh(:)
+  pcoefh_buf(:,2:klev) = pcoefh(:,2:klev)
+  
+  ok_sync = .TRUE.
+
+! Initialization done only once
+!======================================================================
+  IF (iadvtr==1) THEN
+     ALLOCATE( t(klon,klev))
+     ALLOCATE( mfu(klon,klev))  
+     ALLOCATE( mfd(klon,klev))  
+     ALLOCATE( en_u(klon,klev)) 
+     ALLOCATE( de_u(klon,klev)) 
+     ALLOCATE( en_d(klon,klev)) 
+     ALLOCATE( de_d(klon,klev)) 
+     ALLOCATE( coefh(klon,klev)) 
+     ALLOCATE( entr_therm(klon,klev))
+     ALLOCATE( fm_therm(klon,klev))
+     ALLOCATE( pyu1(klon))
+     ALLOCATE( pyv1(klon))
+     ALLOCATE( pftsol(klon,nbsrf))
+     ALLOCATE( ppsrf(klon,nbsrf))
+     
+     ALLOCATE(sh(klon,klev)) 
+     ALLOCATE(da(klon,klev)) 
+     ALLOCATE(phi(klon,klev,klev)) 
+     ALLOCATE(mp(klon,klev)) 
+     ALLOCATE(upwd(klon,klev)) 
+     ALLOCATE(dnwd(klon,klev)) 
+
+     CALL initphysto('phystoke', dtime, dtime*istphy,dtime*istphy,physid)
+     
+     ! Write field phis and aire only once
+     CALL histwrite_phy(physid,lstokenc,"phis",itap,pphis)
+     CALL histwrite_phy(physid,lstokenc,"aire",itap,paire)
+     CALL histwrite_phy(physid,lstokenc,"longitudes",itap,rlon)
+     CALL histwrite_phy(physid,lstokenc,"latitudes",itap,rlat)
+
+  END IF
+  
+  
+! Set to zero cumulating fields
+!======================================================================
+  IF (MOD(iadvtr,istphy)==1.OR.istphy==1) THEN
+     WRITE(lunout,*)'reinitialisation des champs cumules a iadvtr=',iadvtr
+     mfu(:,:)=0.
+     mfd(:,:)=0.
+     en_u(:,:)=0.
+     de_u(:,:)=0.
+     en_d(:,:)=0.
+     de_d(:,:)=0.
+     coefh(:,:)=0.
+     t(:,:)=0.
+     fm_therm(:,:)=0.
+     entr_therm(:,:)=0.
+     pyv1(:)=0.
+     pyu1(:)=0.
+     pftsol(:,:)=0.
+     ppsrf(:,:)=0.
+     sh(:,:)=0.
+     da(:,:)=0.
+     phi(:,:,:)=0.
+     mp(:,:)=0.
+     upwd(:,:)=0.
+     dnwd(:,:)=0.
+     dtcum=0.
+  ENDIF
+  
+
+! Cumulate fields at each time step
+!======================================================================
+  DO k=1,klev
+     DO i=1,klon
+        mfu(i,k)=mfu(i,k)+pmfu(i,k)*pdtphys
+        mfd(i,k)=mfd(i,k)+pmfd(i,k)*pdtphys
+        en_u(i,k)=en_u(i,k)+pen_u(i,k)*pdtphys
+        de_u(i,k)=de_u(i,k)+pde_u(i,k)*pdtphys
+        en_d(i,k)=en_d(i,k)+pen_d(i,k)*pdtphys
+        de_d(i,k)=de_d(i,k)+pde_d(i,k)*pdtphys
+        coefh(i,k)=coefh(i,k)+pcoefh_buf(i,k)*pdtphys
+        t(i,k)=t(i,k)+pt(i,k)*pdtphys
+        fm_therm(i,k)=fm_therm(i,k)+pfm_therm(i,k)*pdtphys
+        entr_therm(i,k)=entr_therm(i,k)+pentr_therm(i,k)*pdtphys
+        sh(i,k) = sh(i,k) + psh(i,k)*pdtphys
+        da(i,k) = da(i,k) + pda(i,k)*pdtphys
+        mp(i,k) = mp(i,k) + pmp(i,k)*pdtphys
+        upwd(i,k) = upwd(i,k) + pupwd(i,k)*pdtphys
+        dnwd(i,k) = dnwd(i,k) + pdnwd(i,k)*pdtphys
+     ENDDO
+  ENDDO
+
+  DO kk=1,klev
+     DO k=1,klev
+        DO i=1,klon
+           phi(i,k,kk) = phi(i,k,kk) + pphi(i,k,kk)*pdtphys
+        END DO
+     END DO
+  END DO
+
+  DO i=1,klon
+     pyv1(i)=pyv1(i)+yv1(i)*pdtphys
+     pyu1(i)=pyu1(i)+yu1(i)*pdtphys
+  END DO
+  DO k=1,nbsrf
+     DO i=1,klon
+        pftsol(i,k)=pftsol(i,k)+ftsol(i,k)*pdtphys
+        ppsrf(i,k)=ppsrf(i,k)+pctsrf(i,k)*pdtphys
+     ENDDO
+  ENDDO
+  
+! Add time step to cumulated time
+  dtcum=dtcum+pdtphys
+  
+
+! Write fields to file, if it is time to do so
+!======================================================================
+  IF(MOD(iadvtr,istphy)==0) THEN 
+
+     ! normalize with time period
+     DO k=1,klev
+        DO i=1,klon
+           mfu(i,k)=mfu(i,k)/dtcum
+           mfd(i,k)=mfd(i,k)/dtcum
+           en_u(i,k)=en_u(i,k)/dtcum
+           de_u(i,k)=de_u(i,k)/dtcum
+           en_d(i,k)=en_d(i,k)/dtcum
+           de_d(i,k)=de_d(i,k)/dtcum
+           coefh(i,k)=coefh(i,k)/dtcum
+           t(i,k)=t(i,k)/dtcum	
+           fm_therm(i,k)=fm_therm(i,k)/dtcum
+           entr_therm(i,k)=entr_therm(i,k)/dtcum
+           sh(i,k)=sh(i,k)/dtcum
+           da(i,k)=da(i,k)/dtcum
+           mp(i,k)=mp(i,k)/dtcum
+           upwd(i,k)=upwd(i,k)/dtcum
+           dnwd(i,k)=dnwd(i,k)/dtcum
+        ENDDO
+     ENDDO
+     DO kk=1,klev
+        DO k=1,klev
+           DO i=1,klon
+              phi(i,k,kk) = phi(i,k,kk)/dtcum
+           END DO
+        END DO
+     END DO
+     DO i=1,klon
+        pyv1(i)=pyv1(i)/dtcum
+        pyu1(i)=pyu1(i)/dtcum
+     END DO
+     DO k=1,nbsrf
+        DO i=1,klon
+           pftsol(i,k)=pftsol(i,k)/dtcum
+           ppsrf(i,k)=ppsrf(i,k)/dtcum
+        ENDDO
+     ENDDO
+
+     ! write fields
+     CALL histwrite_phy(physid,lstokenc,"t",itap,t)
+     CALL histwrite_phy(physid,lstokenc,"mfu",itap,mfu)
+     CALL histwrite_phy(physid,lstokenc,"mfd",itap,mfd)
+     CALL histwrite_phy(physid,lstokenc,"en_u",itap,en_u)
+     CALL histwrite_phy(physid,lstokenc,"de_u",itap,de_u)
+     CALL histwrite_phy(physid,lstokenc,"en_d",itap,en_d)
+     CALL histwrite_phy(physid,lstokenc,"de_d",itap,de_d)
+     CALL histwrite_phy(physid,lstokenc,"coefh",itap,coefh)	
+     CALL histwrite_phy(physid,lstokenc,"fm_th",itap,fm_therm)
+     CALL histwrite_phy(physid,lstokenc,"en_th",itap,entr_therm)
+     CALL histwrite_phy(physid,lstokenc,"frac_impa",itap,frac_impa)
+     CALL histwrite_phy(physid,lstokenc,"frac_nucl",itap,frac_nucl)
+     CALL histwrite_phy(physid,lstokenc,"pyu1",itap,pyu1)
+     CALL histwrite_phy(physid,lstokenc,"pyv1",itap,pyv1)
+     CALL histwrite_phy(physid,lstokenc,"ftsol1",itap,pftsol(:,1))
+     CALL histwrite_phy(physid,lstokenc,"ftsol2",itap,pftsol(:,2))
+     CALL histwrite_phy(physid,lstokenc,"ftsol3",itap,pftsol(:,3))
+     CALL histwrite_phy(physid,lstokenc,"ftsol4",itap,pftsol(:,4))
+     CALL histwrite_phy(physid,lstokenc,"psrf1",itap,ppsrf(:,1))
+     CALL histwrite_phy(physid,lstokenc,"psrf2",itap,ppsrf(:,2))
+     CALL histwrite_phy(physid,lstokenc,"psrf3",itap,ppsrf(:,3))
+     CALL histwrite_phy(physid,lstokenc,"psrf4",itap,ppsrf(:,4))
+     CALL histwrite_phy(physid,lstokenc,"sh",itap,sh)
+     CALL histwrite_phy(physid,lstokenc,"da",itap,da)
+     CALL histwrite_phy(physid,lstokenc,"mp",itap,mp)
+     CALL histwrite_phy(physid,lstokenc,"upwd",itap,upwd)
+     CALL histwrite_phy(physid,lstokenc,"dnwd",itap,dnwd)
+
+
+! phi
+     DO k=1,klev
+        IF (k<10) THEN
+           WRITE(nvar,'(i1)') k
+        ELSE IF (k<100) THEN
+           WRITE(nvar,'(i2)') k
+        ELSE
+           WRITE(nvar,'(i3)') k
+        END IF
+        nvar='phi_lev'//trim(nvar)
+        
+        CALL histwrite_phy(physid,lstokenc,nvar,itap,phi(:,:,k))
+     END DO
+     
+     ! Syncronize file
+!$OMP MASTER
+     IF (ok_sync) CALL histsync(physid)
+!$OMP END MASTER
+     
+     
+     ! Calculate min and max values for some fields (coefficients de lessivage)
+     zmin=1e33
+     zmax=-1e33
+     DO k=1,klev
+        DO i=1,klon
+           zmax=MAX(zmax,frac_nucl(i,k))
+           zmin=MIN(zmin,frac_nucl(i,k))
+        ENDDO
+     ENDDO
+     WRITE(lunout,*)'------ coefs de lessivage (min et max) --------'
+     WRITE(lunout,*)'facteur de nucleation ',zmin,zmax
+     zmin=1e33
+     zmax=-1e33
+     DO k=1,klev
+        DO i=1,klon
+           zmax=MAX(zmax,frac_impa(i,k))
+           zmin=MIN(zmin,frac_impa(i,k))
+        ENDDO
+     ENDDO
+     WRITE(lunout,*)'facteur d impaction ',zmin,zmax
+     
+  ENDIF ! IF(MOD(iadvtr,istphy)==0)
+
+END SUBROUTINE phystokenc
+
+END MODULE phystokenc_mod
Index: /LMDZ5/branches/testing/libf/phylmd/phytrac_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phytrac_mod.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/phytrac_mod.F90	(revision 2408)
@@ -89,26 +89,22 @@
     USE phys_cal_mod, only : hour
     USE dimphy
-    USE infotrac
+    USE infotrac_phy, ONLY: nbtr, type_trac, conv_flg, solsym, pbl_flg
     USE mod_grid_phy_lmdz
     USE mod_phys_lmdz_para
-    USE comgeomphy
     USE iophy
     USE traclmdz_mod
     USE tracinca_mod
     USE tracreprobus_mod
-    USE control_mod
     USE indice_sol_mod
 
     USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
+    USE print_control_mod, ONLY: lunout
+    USE aero_mod, ONLY : naero_grp
 
     IMPLICIT NONE
 
     INCLUDE "YOMCST.h"
-    INCLUDE "dimensions.h"
     INCLUDE "clesphys.h"
-    INCLUDE "temps.h"
-    INCLUDE "paramet.h"
     INCLUDE "thermcell.h"
-    INCLUDE "iniprint.h"
     !==========================================================================
     !                   -- ARGUMENT DESCRIPTION --
@@ -173,8 +169,8 @@
     LOGICAL,INTENT(IN)                       :: aerosol_couple
     REAL,DIMENSION(klon,klev),INTENT(IN)     :: flxmass_w
-    REAL,DIMENSION(klon,klev,9,2),INTENT(IN) :: tau_aero
-    REAL,DIMENSION(klon,klev,9,2),INTENT(IN) :: piz_aero
-    REAL,DIMENSION(klon,klev,9,2),INTENT(IN) :: cg_aero
-    CHARACTER(len=4),DIMENSION(9),INTENT(IN) :: rfname 
+    REAL,DIMENSION(klon,klev,naero_grp,2),INTENT(IN) :: tau_aero
+    REAL,DIMENSION(klon,klev,naero_grp,2),INTENT(IN) :: piz_aero
+    REAL,DIMENSION(klon,klev,naero_grp,2),INTENT(IN) :: cg_aero
+    CHARACTER(len=4),DIMENSION(naero_grp),INTENT(IN) :: rfname 
     REAL,DIMENSION(klon,klev,2),INTENT(IN)   :: ccm 
     !... K.Emanuel
@@ -445,8 +441,8 @@
        WRITE(*,*) 'FIRST TIME IN PHYTRAC : pdtphys(sec) = ',pdtphys,'ecrit_tra (sec) = ',ecrit_tra
        ALLOCATE( source(klon,nbtr), stat=ierr)
-       IF (ierr /= 0) CALL abort_gcm('phytrac', 'pb in allocation 1',1)
+       IF (ierr /= 0) CALL abort_physic('phytrac', 'pb in allocation 1',1)
 
        ALLOCATE( aerosol(nbtr), stat=ierr)
-       IF (ierr /= 0) CALL abort_gcm('phytrac', 'pb in allocation 2',1)
+       IF (ierr /= 0) CALL abort_physic('phytrac', 'pb in allocation 2',1)
 
 
@@ -503,5 +499,5 @@
 !                ELSE 
 !                   WRITE(lunout,*) 'pb it=', it
-!                   CALL abort_gcm('phytrac','pb it scavenging',1)
+!                   CALL abort_physic('phytrac','pb it scavenging',1)
 !                ENDIF
                 !--test OB 
@@ -539,5 +535,5 @@
 
        IF (lessivage.AND.config_inca.EQ.'inca') THEN
-          CALL abort_gcm('phytrac', 'lessivage=T config_inca=inca impossible',1)
+          CALL abort_physic('phytrac', 'lessivage=T config_inca=inca impossible',1)
           STOP
        ENDIF
@@ -740,5 +736,5 @@
     ELSE
        !
-       CALL abort_gcm('iflag_vdf_trac', 'cas non prevu',1)
+       CALL abort_physic('iflag_vdf_trac', 'cas non prevu',1)
        !
     END IF ! couche limite
Index: /LMDZ5/branches/testing/libf/phylmd/plevel.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/plevel.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/plevel.F90	(revision 2408)
@@ -16,7 +16,4 @@
 #endif
   IMPLICIT NONE
-
-  ! ym#include "dimensions.h"
-  ! y#include "dimphy.h"
 
   ! ================================================================
Index: /LMDZ5/branches/testing/libf/phylmd/plevel_new.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/plevel_new.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/plevel_new.F90	(revision 2408)
@@ -18,7 +18,4 @@
 
   IMPLICIT NONE
-
-  ! ym#include "dimensions.h"
-  ! y#include "dimphy.h"
 
   ! ================================================================
